import type * as c4 from '@likec4/core';
import { ast } from '../../ast';
import type { Base } from './Base';
export type WithExpressionV2 = ReturnType<typeof ExpressionV2Parser>;
export declare function ExpressionV2Parser<TBase extends Base>(B: TBase): {
    new (...args: any[]): {
        parseFqnRef(astNode: ast.FqnRef): c4.FqnRef;
        parseFqnExpr(astNode: ast.FqnExpr): c4.FqnExpr;
        parseFqnRefExpr(astNode: ast.FqnRefExpr): c4.FqnExpr.NonWildcard;
        parseFqnExpressions(astNode: ast.FqnExpressions): c4.FqnExpr[];
        parseRelationWhereExpr(astNode: ast.RelationPredicateWhereV2): c4.RelationExpr;
        parseRelationExpr(astNode: ast.RelationExpr): c4.RelationExpr;
        isValid: import("../../validation").IsValidFn;
        readonly services: import("../..").LikeC4Services;
        readonly doc: import("../../ast").ParsedLikeC4LangiumDocument;
        resolveFqn(node: ast.FqnReferenceable): c4.Fqn;
        getAstNodePath(node: c4): any;
        getMetadata(metadataAstNode: ast.MetadataProperty | undefined): {
            [key: string]: string;
        } | undefined;
        convertTags<E extends {
            tags?: ast.Tags;
        }>(withTags?: E | undefined): any;
        parseTags<E extends {
            tags?: ast.Tags;
        }>(withTags?: E): c4.NonEmptyArray<c4.Tag> | null;
        convertLinks(source?: ast.LinkProperty["$container"]): import("../../ast").ParsedLink[] | undefined;
        parseLinks(source?: ast.LinkProperty["$container"]): import("../../ast").ParsedLink[] | undefined;
    };
} & TBase;
